/* wmsorsen
 * Copyright (C) 2006 Ralf Hoffmann.
 * You can contact me at: ralf@boomerangsworld.de
 *   or http://www.boomerangsworld.de/cms/dockapps/wmsorsen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "rc.hh"

#include <iostream>
#include <fstream>
#include <algorithm>
#include <iterator>
#include <sstream>

int readConfig( const std::string &filename,
                config_arg_map &keys )
{
  std::string s;
  std::ifstream ifs( filename.c_str() );
  
  if ( ! ifs.is_open() )
    return -1;
  
  while ( ! ifs.eof() ) {
    std::getline( ifs, s );
    if ( s[0] != '#' ) {
      std::stringstream sts( s );
      std::vector<std::string> tokens;
      
      std::copy( std::istream_iterator<std::string>( sts ),
                 std::istream_iterator<std::string>(),
                 std::back_inserter( tokens ) );

      if ( tokens.size() >= 3 ) {
        std::string key = tokens.front();
        tokens.erase( tokens.begin(), tokens.begin() + 2 );
        keys[key] = tokens;
      }
    }
  }
  return 0;
}
